<?php
// ***************************************************************************
// *   download.php - egy level egy reszenek letoltese a felhasznalohoz      *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 Erno Rigo                                       *
// *   email      :          mcree@freemail.hu                               *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Mon Nov 12 17:09:16 2001
//	letrehoztam - Rigo Erno
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    require_once("session.php");
    require_once("imap.php");

    function pprint($object,$depth='') {
	while (list ($header, $value) = each ($object)) {
	    if((gettype($value)=='object') or (gettype($value)=='array')) {
    		$res.=$depth."<B>$header:</B> ".htmlentities($value)."\n";
		$res.="[<BR>".pprint($value,$depth.'&nbsp;&nbsp;&nbsp;').$depth."]<BR>";
	    } else {
    		$res.=$depth."<B>$header:</B> ".htmlentities($value)."<br>\n";
	    };
	};
	return $res;
    };


    function decodepart($mbox,$msg,$part) {
	switch($part->encoding) {
	    case "BASE64": 
		$body= imap_base64(imap_fetchbody($mbox,$msg,$part->part));
		break;
	    case "QPRINT": 
		$body= imap_qprint(imap_fetchbody($mbox,$msg,$part->part));
		break;
	    case "UNKNOWN":
		$body= imap_fetchbody($mbox,$msg,$part->part);
		break;
	};
	return $body;
    };
    
    sess(); // restore session
    
    $mbox=openmbox(); // open mailbox
    
//    echo "rendering: $mbox,$SESS_MESSAGE,$PART";
    
    $parts=extractparts(imap_fetchstructure($mbox,$SESS_MESSAGE),"");

    foreach($parts as $part) 
	if ($part->part==$POST_PART) {

	    if($part->name=="UNKNOWN") { // ha UNKNOWN a neve ...
		if($part->type=="TEXT/HTML") { // ... es HTML
		    $name="your_mail.html"; // ez lesz a default neve
		} else {  // ... es nem html
		    $name="your_mail.txt";  // .txt lesz a default
		};
	    } else { // ha nem unknown a neve
		$name=$part->name; // akkor ez egy file
	    };
	
	    header("Accept-Ranges: bytes");
	    header("Content-Disposition: attachment; filename=\"$name\"");
	    header("Content-Length: $part->size");
	    
	    if(isset($POST_DOWNLOAD)) { // ha le akarja tolteni...
		header("Content-Type: application/octet-stream");
	    } else { // ha meg akarja nezni
		if(stristr($part->name,".gif")) {
		    header("Content-Type: image/gif");
		    echo decodepart($mbox,$SESS_MESSAGE,$part);    // render the given part
		} else if(stristr($part->name,".jp")) {
		    header("Content-Type: image/jpeg");
		    echo decodepart($mbox,$SESS_MESSAGE,$part);    // render the given part
		} else if(stristr($part->name,".png")) {
		    header("Content-Type: image/png");
		    echo decodepart($mbox,$SESS_MESSAGE,$part);    // render the given part
		} else {  // amugy html
		    header("Content-Type: text/html");
		    echo nl2br(decodepart($mbox,$SESS_MESSAGE,$part));    // render the given part
		};
	    };
	    
	}

//    echo imap_base64(imap_fetchbody($mbox,$SESS_MESSAGE,$PART));

?>
