<?php
// ***************************************************************************
// *   imap.php - imap szerverrel kapcsolatos fuggvenyek                     *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 Erno Rigo                                       *
// *   email      :          mcree@freemail.hu                               *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Wed Aug 01 15:48:21 2001
//	letrehoztam - Rigo Erno
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    function parsemail($str) {
	ereg("@[-._a-zA-Z0-9]+$",$str,$match);
	$res->host=substr($match[0],1,strlen($match[0])-1);
	ereg("^[-._a-zA-Z0-9]+@",$str,$match);
	$res->mailbox=substr($match[0],0,strlen($match[0])-1);
	return $res;
    };

    // mailbox statisztika gyujtes
    function mboxstat($mailbox,$force=false) {
	global	$SESS_USERID, 
		$SESS_MBOXSTAT_CACHE,
		$COOKIE_CACHE_TIMER,
		$SESS_MAILBOX;
		
	//if(!isset($COOKIE_CACHE_TIMER)) setcookie("COOKIE_CACHE_TIMER","on",time()+120);
	
	//$force=true;
	
	//if ($force) echo "force:$mailbox<BR>";
	//if (!$force) echo "cache:$mailbox<BR>";

	if(!isset($SESS_MBOXSTAT_CACHE[$mailbox]) or ($force)) {
	
	    $oldmbox=$SESS_MAILBOX;

	    $mbox=openmbox($mailbox);

	    $mboxinfo=imap_mailboxmsginfo($mbox);
	    
	    $res->size=$mboxinfo->Size;
	    $res->nmsgs=$mboxinfo->Nmsgs;
	    $res->unseen=$mboxinfo->Recent+$mboxinfo->Unread;
	    $res->date=$mboxinfo->Date;
	    
    	    $db=connect();
	    $qry=pg_exec($db,"select name from mailbox where file='$mailbox' and userid='$SESS_USERID'");
	    $rs=pg_fetch_object($qry,0);
	    $res->name=$rs->name;

	    $mbox=openmbox($oldmbox);	// ez azert kell, hogy globalisan visszaaljon az alapertelemezettre
	    
	    $SESS_MBOXSTAT_CACHE[$mailbox]=$res;
	
	} else {
	    $res=$SESS_MBOXSTAT_CACHE[$mailbox];
	};
	
	return $res;
    };

    function extractparts($this_part, $part_no, $PARTS=array()) {
//	global $PARTS;
//	if ($PARTS==NULL) $PARTS=arra;
	if ($this_part->ifdisposition) {	// See if it has a disposition. The only thing I know of that this would be used for would be an attachment. Lets check anyway
    	    if ($this_part->disposition == "ATTACHMENT") {	// If it is an attachment, then we let people download it. First see if they sent a filename
		$att_name = "unknown";
		for ($lcv = 0; $lcv < count($this_part->parameters); $lcv++) {
		    $param = $this_part->parameters[$lcv];
		if ($param->attribute == "NAME") {
                    $att_name = $param->value;
                    break;
                    };
                };
		//echo "attachment at part: $part_no, named: $att_name<BR>";
		$new->type="ATTACHMENT";
		$new->part=$part_no;
		$new->name=$att_name;
		$new->size=$this_part->bytes;
		$new->encoding="BASE64";
	    } else {
		//echo "inline image found at part: $part_no <BR>";
            };
        } else {	// Not an attachment, lets see what this part is...
	    switch ($this_part->type) {
                case TYPETEXT:
                    $mime_type = "TEXT";
                    break;
                case TYPEMULTIPART:
                    $mime_type = "MULTIPART";
                    // Hey, why not use this function to deal with all the parts
                    // of this multipart part :)
                    for ($i = 0; $i < count($this_part->parts); $i++) {
                        if ($part_no != "") {
                    	    $part_no = $part_no.".";
                        }
                        for ($i = 0; $i < count($this_part->parts); $i++) {
                    	    $PARTS=extractparts($this_part->parts[$i], $part_no.($i + 1),$PARTS);
                        }
                    }
                    break;
                case TYPEMESSAGE:
                    $mime_type = "MESSAGE";
                    break;
                case TYPEAPPLICATION:
                    $mime_type = "APLICATION";
                    break;
                case TYPEAUDIO:
                    $mime_type = "AUDIO";
                    break;
                case TYPEIMAGE:
                    $mime_type = "IMAGE";
                    break;
                case TYPEVIDEO:
                    $mime_type = "VIDEO";
                    break;
                case TYPEMODEL:
                    $mime_type = "MODEL";
                    break;
                default:
                    $mime_type = "UNKNOWN"; // hmmm....
            };
            $full_mime_type = $mime_type."/".$this_part->subtype;
                
	    $new->type=$full_mime_type;
	    $new->part=$part_no;
	    $new->size=$this_part->bytes;
	    $new->name="UNKNOWN";

            // Decide what you what to do with this part
            // If you want to show it, figure out the encoding and echo away
            switch ($this_part->encoding) {
                case ENCBASE64:
                        // use imap_base64 to decode
//			echo "base64 encoded $full_mime_type found at part $part_no<BR>";
			$new->encoding="BASE64";
                        break;
                case ENCQUOTEDPRINTABLE:
                        // use imap_qprint to decode
//			echo "quotedprintable encoded $full_mime_type found at part $part_no<BR>";
			$new->encoding="QPRINT";
                        break;
                case ENCOTHER:
                        // not sure if this needs decoding at all
//			echo "unencoded $full_mime_type found at part $part_no<BR>";
			$new->encoding="UNKNOWN";
                        break;
                default:
                        // it is either not encoded or we don't know about it
//			echo "unknown encoded $full_mime_type found at part $part_no<BR>";
			$new->encoding="UNKNOWN";
            };
        };
//	$res[]=$new;
	if($new->part=="") $new->part="1";
	if(	($new->type!="MULTIPART/ALTERNATIVE") and 
		($new->type!="MULTIPART/MIXED")) 
	    $PARTS[]=$new;
	
//	echo pprint($PARTS);
	    
	return $PARTS;
    };

    function openmbox($name=NULL) {
        global	$POST_MAILBOX,		// POST-tal kapott uj mailbox
		$SESS_MAILBOX,		// mailbox
		$SESS_USERNAME,         // felhasznaloi nev
		$SESS_USERID,		// felhasznalo ID
		$SESS_PASSWORD,         // jelszo
		$OPENMBOX;		// az esetlegesen elozoleg megnyitott mailbox azonositoja

	if(!isset($SESS_MAILBOX)) $SESS_MAILBOX="mbox";	// ha nincs aktualis mailbox, az mbox lesz az

	if(isset($POST_MAILBOX)) { // ha uj mailboxot kaptunk post-ban, atallunk arra
    	    $db=connect();
	    $qry=pg_exec($db,"select file from mailbox where id='$POST_MAILBOX' and userid='$SESS_USERID'");
	    $res=pg_fetch_object($qry,0);
	    $SESS_MAILBOX=$res->file; 
	};

	if(isset($name)) $SESS_MAILBOX=$name;	// ha a name-ban kaptunk boxot, azt kell megnyitni
    
	if(!isset($OPENMBOX)) {  // ha meg nem volt megnyitva mailbox ezzel a fuggvennyel
	    $OPENMBOX=imap_open("{localhost:143}$SESS_MAILBOX", "$SESS_USERNAME", "$SESS_PASSWORD");
	} else { // csak mailboxot valtunk
	    imap_reopen($OPENMBOX,"{localhost}$SESS_MAILBOX");
	};
	
	return $OPENMBOX;
    };
    
    function mailaddr($hdrobj) { 
	if($hdrobj->personal=="") $hdrobj->personal=$hdrobj->mailbox;
	return readskin(array("|ADDR_PERSONAL_ENC|","|ADDR_NAME_ENC|","|ADDR_EMAIL_ENC|","|ADDR_MAILBOX|","|ADDR_HOST|","|ADDR_PERSONAL|"),
			array(imap_binary(mime_decode_str($hdrobj->personal)),imap_binary($hdrobj->mailbox),imap_binary("$hdrobj->mailbox@$hdrobj->host"),$hdrobj->mailbox,$hdrobj->host,mime_decode_str($hdrobj->personal)),
			"skin_mailaddress.html");
    };

    function mime_decode_str($str) {
	$base64str="[=][?]iso-[0123456789]{4}-[0123456789]{1,2}[?]B[?]";
	if (eregi($base64str,$str)) {
	    $str=str_replace(" ","",$str);
	    foreach(spliti($base64str,$str) as $st)
		$res.=imap_base64(substr($st,0,-2));
	    return $res;
	};	
	$quotedstr="[=][?]iso-[0123456789]{4}-[0123456789]{1,2}[?]Q[?]";
	if (eregi($quotedstr,$str)) {
	    $str=str_replace(" ","",$str);
	    foreach(spliti($quotedstr,$str) as $st)
		$res.=quoted_printable_decode(str_replace("_"," ",substr($st,0,-2)));
	    return $res;
	};
        return $str;
    };

    function msg_info($mbox,$msg,$force=false) {
	global  $SESS_MSGNFO_CACHE;
	
	$chk=imap_check($mbox);
	if(!isset($SESS_MSGNFO_CACHE[$chk->Mailbox][$msg]) or $force)    {

	$hdr=imap_headerinfo($mbox,$msg,1024,1024); // mail fejlecek lekerese
	if(($hdr->Unseen=='U') or ($hdr->Recent=='N')) {
	    $res->unseen=true;
	} else {
	    $res->unseen=false;
	};
	$res->date=strftime("%b %d",$hdr->udate);
    	if(isset($hdr->cc)) foreach($hdr->cc as $ccaddr) $cc.=readskin(array("|BODY|"),array(mailaddr($ccaddr)),"skin_readmsg_ccbody.html"); // cc-bol tobb is lehet, ezert azokon kulon vegigmegyek
	$res->cc=$cc;
	$res->to=mailaddr($hdr->to[0]);
	$res->to_unmod=$hdr->to;
	$res->from_unmod=$hdr->from;
	$res->from_plain=mime_decode_str($hdr->from[0]->personal);
	if ($res->from_plain=="") $res->from_plain=$hdr->from[0]->mailbox;
	$res->cc_unmod=$hdr->cc;
	$res->from=mailaddr($hdr->from[0]);
	$res->replyto=mailaddr($hdr->reply_to[0]);
	$res->subject=mime_decode_str($hdr->fetchsubject);
	if(!$res->subject) $res->subject=readskin("","","skin_readmsg_nosubj.html");
	
	$parts=extractparts(imap_fetchstructure($mbox,$msg),"");
	foreach($parts as $part) $size+=$part->size;
	$res->size=$size;
	
	$SESS_MSGNFO_CACHE[$chk->Mailbox][$msg]=$res;
	} else {
	    
	    $res=$SESS_MSGNFO_CACHE[$chk->Mailbox][$msg];
	
	};

	return $res;
    };

?>
