<?php
// ***************************************************************************
// *   options.php - felhasznalo egyeni beallitasai                          *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 Erno Rigo                                       *
// *   email      :          mcree@freemail.hu                               *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Wed Dec 5 19:25:13 2001
//	letrehoztam - Rigo Erno
//
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    require_once("GLOBALS.php");
    require_once("readskin.php");
    require_once("postgres.php");

    function options() {
	global	$SESS_USERID,
		$SITEPATH,			// Site eleresi utvonal pl. adduser-hez	
		$POST_ADDUSER_PASSWORD,		// Form adatok... (ahol nem mas, ott string)
		$POST_ADDUSER_PASSWORD_RETYPE,	// ...
		$POST_ADDUSER_REALNAME,		// ...
		$POST_ADDUSER_COMPANY,		// ... 
		$POST_ADDUSER_CITY,		// ...
		$POST_ADDUSER_REMINDER,		// ...
		$POST_ADDUSER_REMIND,		// ...
		$POST_ADDUSER_NEWSLETTER,	// ... (boolean!)
		$POST_SIGN_NAME,
		$POST_SIGN_BODY,
		$POST_SIGN_ID,
		$POST_SIGN_DELETE,
		$POST_SIGN_MODIFY,
		$POST_SIGN_ADD;
		
		
	$db=connect(); // connect database

	$new=false;		
	if(!isset($POST_ADDUSER_PASSWORD)){ // ha meg nem volt connect
//	 $POST_ADDUSER_NEWSLETTER="CHECKED";  //default on
	    $new=true;
	    $qry=pg_exec($db,"select password,realname,company,city,newsletter,reminder,remind from users where id='$SESS_USERID'");
	    $res=pg_fetch_object($qry,0);
	    $POST_ADDUSER_PASSWORD=$res->password;
	    $POST_ADDUSER_PASSWORD_RETYPE=$res->password;
	    $POST_ADDUSER_REALNAME=$res->realname;
	    $POST_ADDUSER_COMPANY=$res->company;
	    $POST_ADDUSER_CITY=$res->city;
	    $POST_ADDUSER_REMINDER=$res->reminder;
	    $POST_ADDUSER_REMIND=$res->remind;
	    if($res->newsletter) {
		$POST_ADDUSER_NEWSLETTER="CHECKED";
	    } else {
		$POST_ADDUSER_NEWSLETTER="";
	    };
	};
	
	$body="skin_options.html";
	
	if(!$new) { // ha volt mar post...
	    if(strlen($POST_ADDUSER_PASSWORD)<3) { // tul rovid jelszo
		$error=readskin("","","skin_adduser_password_short.html");
	    } else if($POST_ADDUSER_PASSWORD!=$POST_ADDUSER_PASSWORD_RETYPE) { // nem egyezik a ket jelszo
		$error=readskin("","","skin_adduser_password_mismatch.html");
	    } else if((strlen($POST_ADDUSER_REALNAME)<3) or (strlen($POST_ADDUSER_COMPANY)<3) or (strlen($POST_ADDUSER_CITY)<3)) { // hianyzo kotelezo mezok
		$error=readskin("","","skin_adduser_nonoptional.html");
	    } else if (pg_numrows(pg_exec($db,"select name from users where name='$POST_ADDUSER_NAME'"))!=0) { // hmm szintaktikailag minden rendben van, mostmar csak az lehet, hogy van mar ilyen user
		$error=readskin("","","skin_adduser_user_exists.html");
	    } else { 
		if($POST_ADDUSER_NEWSLETTER=="CHECKED") {$newsletter="true";} else {$newsletter="false";};
		if(!pg_exec($db,"update users set password='$POST_ADDUSER_PASSWORD',
						  realname='$POST_ADDUSER_REALNAME',
						  company='$POST_ADDUSER_COMPANY',
						  city='$POST_ADDUSER_CITY',
						  newsletter='$newsletter',
						  reminder='$POST_ADDUSER_REMINDER',
						  remind='$POST_ADDUSER_REMIND'
					where id='$SESS_USERID'")) { // beszurjuk sql adatbazisba is
		    $error=readskin("","","skin_adduser_db_insert_error.html");
		} else { // tenyleg minden rendben volt... a felhasznalo hozzaadva...
		
		    $body="skin_options_ok.html"; // errol ertesitjuk is a boldog felhasznalot
		    setcookie("COOKIE_USERNAME",$POST_ADDUSER_NAME,0); // kiteszunk egy cookie-t, hogy a fooldalon mar kapja is a nevet defaultbol
		};
	    }
	} else { // ez az elso megjelenitese az oldalnak, meg nem volt POST
	    $error=""; // ezert nincs hibauzenet sem
	};

	if(isset($POST_SIGN_ADD)) {
	    pg_exec($db,"insert into signs (userid,name,body) values ('$SESS_USERID','$POST_SIGN_NAME','$POST_SIGN_BODY')");
	};
	
	if(isset($POST_SIGN_DELETE)) {
	    pg_exec($db,"delete from signs where userid='$SESS_USERID' and id='$POST_SIGN_ID'");
	};
	
	if(isset($POST_SIGN_MODIFY)) {
	    pg_exec($db,"update signs set name='$POST_SIGN_NAME',body='$POST_SIGN_BODY' where userid='$SESS_USERID' and id='$POST_SIGN_ID'");
	};
	
	$qry=pg_exec($db,"select id,name,body from signs where userid='$SESS_USERID'");
	$row=0;
	while($res=@pg_fetch_object($qry,$row++)) {
	    $sigs.=readskin(array("|SIGN_ID|","|SIGN_NAME|","|SIGN_BODY|"),array($res->id,$res->name,$res->body),"skin_options_signatures.html");
	}	
	

	return readskin(array("|SIGNATURES|","|ADDUSER_REMIND|","|ADDUSER_REMINDER|","|ERROR|","|ADDUSER_NAME|","|ADDUSER_PASSWORD|","|ADDUSER_PASSWORD_RETYPE|","|ADDUSER_REALNAME|","|ADDUSER_COMPANY|","|ADDUSER_CITY|","|ADDUSER_NEWSLETTER|"),
			array($sigs,$POST_ADDUSER_REMIND,$POST_ADDUSER_REMINDER,$error,$POST_ADDUSER_NAME,$POST_ADDUSER_PASSWORD,$POST_ADDUSER_PASSWORD_RETYPE,$POST_ADDUSER_REALNAME,$POST_ADDUSER_COMPANY,$POST_ADDUSER_CITY,$POST_ADDUSER_NEWSLETTER),
			$body);
    };

?>
