<?php
// ***************************************************************************
// *   readskin.php - skin valaszto, beolvaso, kezelo modul                  *
// *-------------------------------------------------------------------------*
// *   copyright  : (C) 2001 by Zoltan Komaromi and Erno Rigo                *
// *   email      : 		komi_@freemail.hu   mcree@freemail.hu	     *
// ***************************************************************************
//
// ***************************************************************************
// *                                                                         *
// *   This product includes PHP, freely available from http://www.php.net   *
// *                                                                         *
// *   This program is free software. Redistribution and use in source and   *
// *   binary forms, with or without modification is possible under the      *
// *   terms of the PHP License, version 2.02 published by the PHP Group.    *
// *                                                                         *
// *   This software consists of voluntary contributions made by many        *
// *   individuals on behalf of the PHP Group.                               *
// *                                                                         *
// ***************************************************************************
//
// DEVELOPMENT HISTORY:
//
// Wed Aug 1 15:48:21 2001
//      letrehoztam - Rigo Erno
// 
// Mon Aug 6 09:03:51 2001
//	fejlesztes lezarva - RE
//
// Tue Aug 14 09:21:15 2001
//	ha valamelyik konyvtar nem talalhato, mostmar visszaall 'default'-ra, ha maga a skinfile nem talalhato, 
//	akkor lehal, de ilyen a kesz progiban nem fordulhat elo - RE
//
// Fri Sep 7 10:55:05 2001
//	filebeolvasas gyorsitasa, a fgets()-es, while-os megoldas irto lassu a file() hivashoz kepest - RE 
//
// Wed Sep 19 10:08:53 2001
//	a chooseskin() skineit az ujabb rendszerhez igazitottam - RE
//
//---------------------------------------------------------------------------------------------------------------------------

//-------------------------------
// SKIN VALASZTO ES KEZELO MODUL
//-------------------------------

    require_once("GLOBALS.php");
    
    // bemenet:
    // ~~~~~~~
    //	globalis valtozok, lasd a fuggvenyben
    //
    // kimenet:
    // ~~~~~~~
    // 	skin valaszto modul body
    // 	a skint a COOKIE_SKIN_CURRENT cookieben tarolja, a readskin onnan veszi az alkonyvtar cimet
    //
    function chooseskin() {
	global	$SKIN_PATH,		// skin eleresi utvonal, globalis
		$SERVER_NAME,		// skin eleresi utvonal site, egyszeruen hozzairjuk a $SKIN_PATH-hoz
		$CHOOSESKIN_VALUE,	// GET/POST: ezt a skint valasztotta az user
		$COOKIE_SKIN_CURRENT;	// cookie, jelenleg ez a skin van kivalasztva az usernel		

	if (isset($CHOOSESKIN_VALUE)) { // ha kaptunk uj skinnevet POST-tal
	    setcookie("COOKIE_SKIN_CURRENT",$CHOOSESKIN_VALUE,time() + 60*60*24*350*10); // cca 10 evig
	    $COOKIE_SKIN_CURRENT=$CHOOSESKIN_VALUE; // mostantol el az uj skin
	};
    	$dd=opendir("$SKIN_PATH/$SERVER_NAME");  // megnyitjuk az ehhez a sitehoz tartozo skin konyvtarat
	while (false!==($file = readdir($dd))) {  // beolvassuk az osszes filenevet
	    if ($file != "." && $file != "..") {  // kiveve persze a . es a .. 
		require("$SKIN_PATH/$SERVER_NAME/$file/SKIN_INFO.php"); // infot kerunk az aktualis skin alkonyvtarbol
		$res = $res . readskin(array("|ACTION|","|SKINNAME|","|SKININFO|"),array($PHP_SELF,$file,$SKIN_INFO),"skin_chooseskin_body.html"); // kitesszukeztet
	    };
	};
	closedir($dd); // konyvtar leolt
	$res = readskin(array("|CONTENT|"),array($res),"skin_chooseskin.html");
	return $res;
    };

    // bemenet:
    // ~~~~~~~
    //	globalis valtozok, lasd a fuggvenyben
    //	$tokens - tokenek tombje
    //	$variables - ertekek tombje
    //	$skinfile - skin fajlnev, relativ
    //
    // kimenet:
    // ~~~~~~~
    // 	beolvassa a $SKIN_PATH/$SERVER_NAME/$COOKIE_SKIN_CURRENT/$skinfile html fajlt, 
    //  a $token-eket $variable-ekre csereli, es az eredmennyel visszater
    //
    //  ha a skin neve.X fajl letezik ("skinnev.0", "skinnev.1", stb.), X-et ciklikusan cserelgeti, igy
    //  lehet valtakozo szinu tablasorokat es hasonlo periodikusan valtozo dolgokat kitenni.
    //
    function readskin($tokens,$variables,$skinfile) {
	global 	$SESS_SKINPATH,
		$SKIN_PATH,		// skin eleresi utvonal, globalis
		$COOKIE_SKIN_CURRENT,	// cookie, jelenleg ez a skin van kivalasztva az usernel, egyszeruen hozzairjuk a $SKIN_PATH-hoz
		$SERVER_NAME,		// skin eleresi utvonal site, egyszeruen hozzairjuk a $SKIN_PATH-hoz
		$SKIN_ROTATE,		// globalis valtozo, asszociativ tomb, $SKIN_ROTATE[skin] = az adott skin hanyadik verziojat kell most megjeleniteni, ha undef, akkor a 0. verzio kell
		$PHPSESSID;		// PHP session id
		
	if (!isset($SERVER_NAME))  // ha nincs definialva erre a vboltra skin_site (ami nehezen hiheto, mert a curr.php-nek ez a feladata)...
	    $SERVER_NAME="default";  // legyen default
	if (!@is_readable("$SKIN_PATH/$SERVER_NAME")) // ha definialva van, de nem olvashato...
	    $SERVER_NAME="default"; // akkor is legyen default

        if (!isset($COOKIE_SKIN_CURRENT))   // ha nincs cookieben kinn az aktualis usernel, hogy mi a skin...
	    $COOKIE_SKIN_CURRENT="default"; // default skint kap
	if (!@is_readable("$SKIN_PATH/$SERVER_NAME/$COOKIE_SKIN_CURRENT"))  // ha kinn van cookieben, de nem olvashato (letorolte a designer ezt a skint, de kozben valaki beallitotta maganak)...
	    $COOKIE_SKIN_CURRENT="default"; // legyen akkor is default
	    
	if(@is_readable("$SKIN_PATH/$SERVER_NAME/$COOKIE_SKIN_CURRENT/$skinfile.0")) { // ha letezik "skinneve.0" ...
	    if(!isset($SKIN_ROTATE[$skinfile])) { // ha meg sosem tettuk ki ezt a skint ...
		$SKIN_ROTATE[$skinfile]=0; // most tesszuk ki eloszor... persze 0-tol sorszamozva
	    };
	    if(@is_readable("$SKIN_PATH/$SERVER_NAME/$COOKIE_SKIN_CURRENT/$skinfile.".$SKIN_ROTATE[$skinfile])) { // ha olvashato a legutobb kitett skin utan szamsorrendben kovetkezo... (eg. skinneve.0-t tettuk ki legutobb, es a tombben noveltuk az erteket, akkor most a skinneve.1-et probaljuk meg kitenni, de csak akkor, ha letezik)
		$sfile=$skinfile.".".$SKIN_ROTATE[$skinfile];   // ezt tesszuk most ki...
		$SKIN_ROTATE[$skinfile]++; // szamsorrendben a kovetkezore allunk ('tippelunk', hogy az lesz a kovetkezo)...
	    } else { // ha a kovetkezo skin, amit tippeltunk mar nem letezik...
		$sfile=$skinfile.".0"; // visszaallunk a 0.-ra
		$SKIN_ROTATE[$skinfile]=1; // a kovetkezo tippunk az 1.
	    };
	} else { // ha nincs skinneve.0, biztos nem is akar rotate funkciot hasznalni a designer
	    $sfile = $skinfile;  // bekenhagyjuk a nevet
	};
	
	$tokens[]="|ACTION|"; $variables[]=$PHP_SELF; // ezt alapertelmezesbol lecsereljuk. VIGYAZAT! a $PHP_SELF megorzi a GET metodussal atadott http valtozokat! ahol ezt nem akarod, 'main.php' a helyes target (<form action="main.php">, vagy <form action="|ACTION|"> nem mindegy)
	$tokens[]="|SESSID|"; $variables[]=$PHPSESSID; // ezt is
	$tokens[]="|SKIN_PATH|"; $variables[]="skins/$SERVER_NAME/$COOKIE_SKIN_CURRENT";
	
	$SESS_SKINPATH="$SKIN_PATH/$SERVER_NAME/$COOKIE_SKIN_CURRENT";
	
	foreach(file("$SKIN_PATH/$SERVER_NAME/$COOKIE_SKIN_CURRENT/$sfile") as $line) { // a fajl minden sorara...
	    $res.=str_replace ($tokens, $variables, $line); // kicsereljuk a tokeneket variablesre
	};

	return $res;
    };

?>
